<?php
/**
 Admin Page Framework v3.5.7.1 by Michael Uno
 Generated by PHP Class Files Script Generator <https://github.com/michaeluno/PHP-Class-Files-Script-Generator>
 <http://en.michaeluno.jp/admin-page-framework>
 Copyright (c) 2013-2015, Michael Uno; Licensed under MIT <http://opensource.org/licenses/MIT>
 */
abstract class AdminPageFramework_Factory_View extends AdminPageFramework_Factory_Model {
    public function __construct($oProp) {
        parent::__construct($oProp);
        if (!$this->_isInThePage()) {
            return;
        }
        if ($this->oProp->bIsAdminAjax) {
            return;
        }
        if (is_network_admin()) {
            add_action('network_admin_notices', array($this, '_replyToPrintSettingNotice'));
        } else {
            add_action('admin_notices', array($this, '_replyToPrintSettingNotice'));
        }
        $this->oProp->aFieldCallbacks = $this->_getFormFieldElementCallbacks();
    }
    private function _getFormFieldElementCallbacks() {
        return array('hfID' => array($this, '_replyToGetInputID'), 'hfTagID' => array($this, '_replyToGetInputTagIDAttribute'), 'hfName' => array($this, '_replyToGetInputNameAttribute'), 'hfNameFlat' => array($this, '_replyToGetFlatInputName'), 'hfClass' => array($this, '_replyToGetInputClassAttribute'),) + $this->oProp->aFieldCallbacks;
    }
    public function _replyToGetInputID() {
        $_aParams = func_get_args() + array(null, null, null, null);
        $sInputIDAttribute = $_aParams[0];
        return $sInputIDAttribute;
    }
    public function _replyToGetInputTagIDAttribute() {
        $_aParams = func_get_args() + array(null, null, null, null);
        $sTagIDAttribute = $_aParams[0];
        return $sTagIDAttribute;
    }
    public function _replyToGetInputNameAttribute() {
        $_aParams = func_get_args() + array(null, null, null);
        $sNameAttribute = $_aParams[0];
        return $sNameAttribute;
    }
    public function _replyToGetFlatInputName() {
        $_aParams = func_get_args() + array(null, null, null, null);
        $sFlatName = $_aParams[0];
        return $sFlatName;
    }
    public function _replyToGetInputClassAttribute() {
        $_aParams = func_get_args() + array(null, null, null, null);
        $sClassAttribute = $_aParams[0];
        return $sClassAttribute;
    }
    public function isSectionSet(array $aField) {
        $aField = $aField + array('section_id' => null,);
        return $aField['section_id'] && '_default' !== $aField['section_id'];
    }
    static private $_bSettingNoticeLoaded = false;
    public function _replyToPrintSettingNotice() {
        if (!$this->_isInThePage()) {
            return;
        }
        if (self::$_bSettingNoticeLoaded) {
            return;
        }
        self::$_bSettingNoticeLoaded = true;
        $_iUserID = get_current_user_id();
        $_aNotices = $this->oUtil->getTransient("apf_notices_{$_iUserID}");
        if (false === $_aNotices) {
            return;
        }
        $this->oUtil->deleteTransient("apf_notices_{$_iUserID}");
        if (isset($_GET['settings-notice']) && !$_GET['settings-notice']) {
            return;
        }
        $this->_printSettingNotices($_aNotices);
    }
    private function _printSettingNotices($aNotices) {
        $_aPeventDuplicates = array();
        foreach (array_filter(( array )$aNotices, 'is_array') as $_aNotice) {
            $_sNotificationKey = md5(serialize($_aNotice));
            if (isset($_aPeventDuplicates[$_sNotificationKey])) {
                continue;
            }
            $_aPeventDuplicates[$_sNotificationKey] = true;
            echo $this->_getSettingNotice($_aNotice);
        }
    }
    private function _getSettingNotice(array $aNotice) {
        if (!isset($aNotice['aAttributes'], $aNotice['sMessage'])) {
            return '';
        }
        $aNotice['aAttributes']['class'] = isset($aNotice['aAttributes']['class']) ? $aNotice['aAttributes']['class'] . ' admin-page-framework-settings-notice-container' : 'admin-page-framework-settings-notice-container';
        return "<div " . $this->oUtil->generateAttributes($aNotice['aAttributes']) . ">" . "<p class='admin-page-framework-settings-notice-message'>" . $aNotice['sMessage'] . "</p>" . "</div>";
    }
    public function _replyToGetFieldOutput($aField) {
        $_oField = new AdminPageFramework_FormField($aField, $this->oProp->aOptions, $this->_getFieldErrors(), $this->oProp->aFieldTypeDefinitions, $this->oMsg, $this->oProp->aFieldCallbacks);
        $_sOutput = $this->oUtil->addAndApplyFilters($this, array('field_' . $this->oProp->sClassName . '_' . $aField['field_id']), $_oField->_getFieldOutput(), $aField);
        return $_sOutput;
    }
}